import robo.Robo;
import static robo.Constant.*;
class RotateAndFire extends robo.Robo {
    public RotateAndFire(String name, String colour){
	super(name,colour);
    }
    private double ptwice(double x){
	if(x<0){
	    return 0;
	}
	return 2*x;
    }
    @Override
    public void game_starts(){
	initValue();
	rotate_allowed = true;
	shots_hit = 0;
	last_shot_hit_time = -2.0;
	current_time = 0;
	
	radar_and_cannon_rotate =
	    robot_cannon_max_rotate - ptwice(robot_rotate);
	rotate( 1, robot_rotate );
	rotate( 6, radar_and_cannon_rotate );
	accelerate( acceleration );
    }

    @Override
    public void radar_robot(double dist, double angle ){
	if( radar_and_cannon_rotate != - robot_rotate ){
	    radar_and_cannon_rotate = - robot_rotate;
	    rotate( 6, radar_and_cannon_rotate );
	}
	if( dist < 2 && acceleration != 0.0 ){
	    acceleration = 0.0;
	    accelerate( acceleration );
	    brake_value = 1.0;
	    brake( brake_value );
	    if( debug_level >= 1 ){
		debug("Brakes locked: Robot found and at distance "+dist);
	    }
	}
	shoot( 2 );
    }
    @Override
    public void radar_shot(double dist, double angle ){
	if( radar_and_cannon_rotate !=
	    robot_cannon_max_rotate - ptwice(robot_rotate)){
	    radar_and_cannon_rotate =
		robot_cannon_max_rotate - ptwice(robot_rotate);
	    rotate( 6, radar_and_cannon_rotate );
	}
    }
    @Override
    public void radar_wall(double dist, double angle ){
	if( radar_and_cannon_rotate !=
	    robot_cannon_max_rotate - ptwice(robot_rotate)){
	    radar_and_cannon_rotate =
		robot_cannon_max_rotate - ptwice(robot_rotate);
	    rotate( 6, radar_and_cannon_rotate );
	}
	double old_acc = acceleration;
	double mod_angle = Math.IEEEremainder( angle, 2 * Math.PI );
	if( mod_angle < 1 * Math.PI / 3 || mod_angle > 5 * Math.PI / 3 ){
	    if( dist < 1.0 ){
		acceleration = 0.0;
		brake_value = 1.0;
	    }else{
		acceleration = 1.0;
		brake_value = 0.0;
	    }
	}
	if( old_acc != acceleration ){
	    accelerate( acceleration );
	    brake( brake_value );
	    if( debug_level >= 4 ){
		debug("Acceleration: "+acceleration);
		debug("Brake: "+brake_value);
	    }
	    if( debug_level == 5 ){
		debug("Modular angle, Angle: "+mod_angle+", "+angle);
	    }
	}
    }
    @Override
    public void radar_cookie(double dist, double angle ){
	if( radar_and_cannon_rotate !=
	    robot_cannon_max_rotate - ptwice(robot_rotate)){
	    radar_and_cannon_rotate =
		robot_cannon_max_rotate - ptwice(robot_rotate);
	    rotate( 6, radar_and_cannon_rotate );
	}
	if( debug_level >= 2 ){
	    debug("Cookie found at ("
		  +(current_x_coordinate + dist*Math.cos(angle + current_robot_angle))
		  +","
		  +(current_y_coordinate + dist*Math.sin(angle + current_robot_angle))
		  +")");
	    debug("I am at  ("+current_x_coordinate+","+current_y_coordinate
		  +") at angle "+current_robot_angle);
	}
    }
    @Override
    public void radar_mine(double dist,  double angle ){
	if( radar_and_cannon_rotate !=
	    robot_cannon_max_rotate - ptwice(robot_rotate)){
	    radar_and_cannon_rotate =
		robot_cannon_max_rotate - ptwice(robot_rotate);
	    rotate( 6, radar_and_cannon_rotate );
	}
	shoot( shot_min_energy );
	if( debug_level >= 2 ){
	    debug("Mine found at ("
		  +(current_x_coordinate + dist*Math.cos(angle + current_robot_angle))
		  +","
		  +(current_y_coordinate + dist*Math.sin(angle + current_robot_angle))
		  +")");
	    debug("I am at  ("+current_x_coordinate+","+current_y_coordinate
		  +") at angle "+current_robot_angle);
	}
    }

    @Override
    public void coordinates(double x, double y, double rotation){
	if( send_robot_coordinates == 0 ) return;
	current_x_coordinate = x;
	current_y_coordinate = y;
	current_robot_angle = rotation;
    }
    @Override
    public void info(double time, double speed, double cannon_angle ){
	current_time = time;
	if( current_time - last_shot_hit_time > 2.0 ){
	    shots_hit = 0;
	}
    }
    @Override
    public void rotation_reached(int what ){
	if( (what & 1) == 1 ){
	    rotate_allowed = true;
	    acceleration_change_allowed = true;
	    int direction = (int) Math.random()*2;
	    if( direction == 0 ){
		direction = -1;
	    }
	    robot_rotate = 0.53 * direction;
	    acceleration = 1.0;
	    accelerate( acceleration );
	}
    }
    @Override
    public void robots_left(int number_of_robots ){
	number_of_robots_left = number_of_robots;
    }
    @Override 
    public void collision_shot(double angle ){
	shots_hit++;
	last_shot_hit_time = current_time;
	if( debug_level == 5 ){
	    debug("Number of shots hit "+shots_hit);
	}
	if( shots_hit > 5 ){
	    int direction = (int) Math.random()*2;
	    if( direction == 0 ){
		direction = -1;
	    }
	    robot_rotate = robot_max_rotate * direction;
	    rotate_amount( 1, robot_rotate, Math.PI/2 );
	    rotate_allowed = false;
	    acceleration = robot_max_acceleration;
	    accelerate( acceleration );
	    acceleration_change_allowed = false;
	    if( debug_level >= 3 ){
		debug("New rotation: "+robot_rotate);
		debug("New acceleration: "+acceleration);
	    }
	    shots_hit = 0;
	    print( "Hit too many times! Flee!" );
	}
    }
    private int shots_hit;
    private double last_shot_hit_time;
    private int number_of_robots_left;
    private double current_time;
    private double current_x_coordinate;
    private double current_y_coordinate;
    private double current_robot_angle;

    public static void main(String[] arg){
	Robo raf = new RotateAndFire("Rotate&Fire(new)", "9977dd");
	raf.robot_option( USE_NON_BLOCKING, 0 );
	raf.check_messages();
    }
}

