package robo;
import java.util.*;
import static robo.GameOption.*;
abstract class Action {
    Action[] actionArray = new Action[]{
	new Initialize()
    };
    abstract public void get(Scanner sc);
    final protected void initialize(int first_seq){
	if( first_seq == 1 ){
	    name( robot_name);
	    colour( robot_colour, robot_colour );
	}
    }
    protected void your_name(String prev_name ){}
    protected void your_colour(String colour ){}
    final protected void game_option(int option, double value ){
	switch( option ){
	case ROBOT_MAX_ROTATE:
	    robot_max_rotate = value;
	    break;
	case ROBOT_CANNON_MAX_ROTATE:
	    robot_cannon_max_rotate = value;
	    break;
	case ROBOT_RADAR_MAX_ROTATE:
	    robot_radar_max_rotate = value;
	    break;
	case ROBOT_MAX_ACCELERATION:
	    robot_max_acceleration = value;
	    break;
	case ROBOT_MIN_ACCELERATION:
	    robot_min_acceleration = value;
	    break;
	case ROBOT_START_ENERGY:
	    robot_start_energy = value;
	    break;
	case ROBOT_MAX_ENERGY:
	    robot_max_energy = value;
	    break;
	case ROBOT_ENERGY_LEVELS:
	    robot_energy_levels = value;
	    break;
	case SHOT_SPEED:
	    shot_speed = value;
	    break;
	case SHOT_MIN_ENERGY:
	    shot_min_energy = value;
	    break;
	case SHOT_MAX_ENERGY:
	    shot_max_energy = value;
	    break;
	case SHOT_ENERGY_INCREASE_SPEED:
	    shot_energy_increase_speed = value;
	    break;
	case TIMEOUT:
	    timeout = value;
	    break;
	case DEBUG_LEVEL:
	    debug_level = value;
	    break;
	case SEND_ROBOT_COORDINATES:
	    send_robot_coordinates = (int)rint(value);
	    break;
	}
    }
protected  boolean quitting;
  // Boolean variables to control if it is allowed to change robot
  // rotation and acceleration.
  boolean rotate_allowed;
  boolean acceleration_change_allowed;


  // These variables contains the current values of the robot rotation,
  // acceleration and brake.
  double radar_and_cannon_rotate;
  double robot_rotate;
  double acceleration;
  double brake_value;
  // All game options are stored in these variables.
  double robot_max_rotate;
  double robot_cannon_max_rotate;
  double robot_radar_max_rotate;
  double robot_max_acceleration;
  double robot_min_acceleration;
  double robot_start_energy;
  double robot_max_energy;
  double robot_energy_levels;
  double shot_speed;
  double shot_min_energy;
  double shot_max_energy;
  double shot_energy_increase_speed;
  double timeout;
  double debug_level;
  int send_robot_coordinates;
}
class Initialize extends Action {
    public void get(Scanner sc){
	intialize(sc.nextInt());
    }
}
class YourName extends Action {
    public void get(Scanner sc){
	yourName(sc.next());
    }
}    
class YourColor extends Action {
    public void get(Scanner sc){
	yourColour(sc.next());
    }
}    
class GameOption extends Action {
    public void get(Scanner sc){
	gameOption(sc.nextInt(), sc.nextDouble());
    }
}    
class GameStarts extends Action {
    public void get(Scanner sc){
	gameStarts();
    }
}    
enum ObjectType
{ 
    NOOBJECT (-1), 
	ROBOT(0), 
	SHOT(1), 
	WALL(2), 
	COOKIE(3), 
	MINE(4),
	LAST_OBJECT_TYPE(5);
    private int value;
    ObjectType(int value){
	this.value = value;
    }
    public int getValue(){
	return value;
    }
    private HashMap<Integer, ObjectType> dic;
    public static ObjectType getInstance(int value){
	if(dic == null){
	    dic = new HashMap<Integer, ObjectType>();
	    for(ObjectType o : ObjectType.values()){
		dic.put(o.getValue(),o);
	    }
	}
	return dic.get(value);
    }
}
class Radar extends Action {
    public void get(Scanner sc){
	double dist = sc.nextDouble();
	ObjectType object = ObjectType.getInstance(sc.nextInt());
	double angle = sc.nextDouble();
	switch(object){
	case NOOBJECT:
	    radar_noobject( dist, angle );
	    break;
	case ROBOT:
	    radar_robot( dist, angle );
	    break;
	case WALL:
	    radar_wall( dist, angle );
	    break;
	case SHOT:
	    radar_shot( dist, angle );
	    break;
	case COOKIE:
	    radar_cookie( dist, angle );
                break;
	case MINE:
	    radar_mine( dist, angle );
	    break;
	default:
	    System.out.println("Print Unknown Object seen!");
	    break;
	}
    }
}
