package robo;
enum MessageToRobot
{
  UNKNOWN_MESSAGE_TO_ROBOT
      // = -1
,
  INITIALIZE,
  YOUR_NAME,
  YOUR_COLOUR,
  //  BIN_DATA_TO,
  //  ASCII_DATA_TO,
  //  LOAD_DATA_FINISHED,
  GAME_OPTION,
  GAME_STARTS,
  RADAR,
  INFO,
  COORDINATES,
  ROBOT_INFO,
  ROTATION_REACHED,
  ENERGY,
  ROBOTS_LEFT,
  COLLISION,
  WARNING,
  DEAD,
  GAME_FINISHES,
  //  SAVE_DATA,
  EXIT_ROBOT
}

enum MessageFromRobot
{
  UNKNOWN_MESSAGE_FROM_ROBOT
      // = -1
      ,
  ROBOT_OPTION,
  NAME,
  COLOUR,
  //  LOAD_DATA,
  ROTATE,
  ROTATE_TO,
  ROTATE_AMOUNT,
  SWEEP,
  ACCELERATE,
  BRAKE,
  BREAK,
  SHOOT,
  PRINT,
  DEBUG,
  DEBUG_LINE,
  DEBUG_CIRCLE

  //  BIN_DATA_FROM,
  //  ASCII_DATA_FROM,
  //  SAVE_DATA_FINISHED
}

enum Argument
{
  NONE,
  STRING,
  DOUBLE,
  INT,
  HEX
  //  BINDATA
}

enum Warning
{
  UNKNOWN_MESSAGE //=0
,
  PROCESS_TIME_LOW //=1
,
  //  ENERGY_LOW,
  //VARIABLE_OUT_OF_RANGE,
  MESSAGE_SENT_IN_ILLEGAL_STATE //=2
,
  UNKNOWN_OPTION //=3
,
      OBSOLETE_KEYWORD //=4
,
      NAME_NOT_GIVEN //=5
,
      COLOUR_NOT_GIVEN //=6
}

class GameOption {
    final public static int ROBOT_MAX_ROTATE=0 ;
    final public static int ROBOT_CANNON_MAX_ROTATE =1;
    final public static int ROBOT_RADAR_MAX_ROTATE =2;
    final public static int 	ROBOT_MAX_ACCELERATION =3;
    final public static int 	ROBOT_MIN_ACCELERATION =4;
    final public static int 	ROBOT_START_ENERGY =5;
    final public static int 	ROBOT_MAX_ENERGY =6;
    final public static int 	ROBOT_ENERGY_LEVELS =7;
    final public static int 	SHOT_SPEED =8;
    final public static int 	SHOT_MIN_ENERGY =9;
    final public static int 	SHOT_MAX_ENERGY =10;
    final public static int 	SHOT_ENERGY_INCREASE_SPEED =11;
    final public static int 	TIMEOUT =12;
    final public static int 	DEBUG_LEVEL =13;
            // 0 - no debug, 5 - highest debug level
    final public static int 	SEND_ROBOT_COORDINATES = 14;
    // 0 - no coordinates, 
    // 1 - coordniates are given relative the starting position
    // 2 - absolute coordinates 
}

enum RobotOption
{
    SIGNAL //=2
,                   // 0 - no signal, > 1 - signal to send (e.g. SIGUSR1 or SIGUSR2) 
	SEND_SIGNAL //=0
,              // 0 - false, 1 - true
	SEND_ROTATION_REACHED //=1
,    // 0 - no messages
                              // 1 - messages when RotateTo and RotateAmount finished
                              // 2 - messages also when sweep direction is changed

	USE_NON_BLOCKING //=3          // 0 - false, 1 - true 
                              // This option should always be sent as soon as possible

}

class Message
{
    final String msg;
    final int numberOfArgs;
    final Argument[] argType;
    public Message(String msg, int num, Argument[] arg){
	this.msg = msg;
	this.numberOfArgs = num;
	this.argType = arg;
    }
}

