package robo;
import java.io.*;
import java.util.*;
class Matcher {
    private String str;
    private int start;
    private int end;
    public Matcher(String str){
	this.str = str;
	start=-1;
	end=-1;
    }
    public boolean find(){
	start=end;
	do{
	    start++;
	    if(str.length()<=start){
		return false;
	    }
	}while(Character.isWhitespace(str.charAt(start)));
	end=start;
	do{
	    end++;
	    if(end>=str.length()){
		break;
	    }
	}while(!Character.isWhitespace(str.charAt(end)));
	return true;
    }
    public String group(){
	return str.substring(start,end);
    }
    public int end(){
	return end;
    }
}

public class Scanner implements Iterator<String> {
    private BufferedReader br;
    private String line;
    //    private Pattern p=Pattern.compile("\\S+");
    private Matcher matcher;
    public void remove(){}
    private boolean unread=false;
    public Scanner(InputStream is){
	init(new InputStreamReader(is));
    }
    public Scanner(String str){
	init(new StringReader(str));
    }
    private void init(Reader r){
	this.br = new BufferedReader(r);
    }
    public boolean hasNext() {
	if(unread){
	    return true;
	}
	try{
	    read();
	    unread=true;
	    return true;
	}catch(IOException e){
	    return false;
	}
    }
    private void read() throws IOException {
	while(matcher==null || !matcher.find()){
	    if((line=br.readLine())==null){
		throw new IOException();
	    }
	    //	    matcher = p.matcher(line);
	    matcher = new Matcher(line);
	}
    }
    public String next() {
	try{
	    if(!unread){
		read();
	    }
	    unread=false;
	    return matcher.group();
	}catch(IOException e){
	    throw new NoSuchElementException();
	}
    }
    public int nextInt(){
	String result = next();
	return Integer.parseInt(result);
    }
    public double nextDouble(){
	String result = next();
	return Double.parseDouble(result);
    }
    public String nextLine(){
	String result = line.substring(matcher.end());
	matcher = null;
	return result;
    }
    public static void main(String[] arg) throws Exception {
	Scanner s = new Scanner(System.in);
	while(s.hasNext()){
	    System.out.println(s.next());
	}
    }
}