import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;

public abstract class TestBase implements ITest
{
// ITest overrides
public final String getName()
{
	return m_strName;
}

public final boolean isInterruptibleTest()
{
	return m_bInterruptible;
}

public final void dispose(Thread thrd)
{
	try
	{
		if (thrd.isInterrupted())
			out().println("--> Interrupted!");
		out().println("--> End "+m_strName);
		m_strm.close();
		m_strmBA.writeTo(System.out);
	}
	catch (IOException e)
	{
		e.printStackTrace();
	}
}

// Runnable overrides
public abstract void run();

// protected //
protected TestBase(String strName, boolean bInterruptible)
{
	m_strName = strName;
	m_bInterruptible = bInterruptible;

	// Set up my writers
	m_strmBA = new ByteArrayOutputStream();
	m_strm = new PrintStream(new BufferedOutputStream(m_strmBA));
	out().println("--> Begin "+m_strName);
}

protected final PrintStream out()
{
	return m_strm;
}

protected final void dump(Throwable thw)
{
	out().println
	(
		"EXCEPTION: "+thw.getClass().getName()+": "+thw.getMessage()
	);
}

// private //
private String m_strName;
private boolean m_bInterruptible;
private ByteArrayOutputStream m_strmBA;
private PrintStream m_strm;
}
