/*
 * Copyright (c) 2002 by Mohan Embar. All Rights Reserved
 * May not be reproduced or distributed without permission from the author.
 */

package com.thisiscool.gcj.tests.guiconsole;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

public class GUILauncher
{
public static void main(String[] args)
{
    new GUILauncher(args).run();
}

// private //
private Label m_lbl;

private GUILauncher(String[] args)
{}

private void run()
{
    Display dsp = new Display();
    Shell shl = new Shell(dsp);

    initUI(dsp,shl);

    shl.open();
    while (!shl.isDisposed())
    {
        if (!dsp.readAndDispatch()) dsp.sleep();
    }
}

private void initUI(Display dsp, Shell shl)
{
    shl.setText("GUI Spawns Console Test App");


    initCtrls(shl);

    shl.pack();

    // Center it on the screen.
    Rectangle rctScreen = dsp.getBounds();
    Rectangle rctShell = shl.getBounds();
    shl.setLocation
    (
        (rctScreen.width >> 1) - (rctShell.width >> 1),
        (rctScreen.height >> 1) - (rctShell.height >> 1)
    );
}

private void initCtrls(Shell shl)
{
    GridLayout glyo = new GridLayout();
    shl.setLayout(glyo);
    glyo.numColumns = 1;

	m_lbl = new Label(shl, SWT.NONE);
	m_lbl.setText("Text from spawned process will be printed here.");

    Button bn;

    bn = new MyButton(shl, "Spawn &GUI App").getButton();
    bn.addSelectionListener
    (
        new SelectionAdapter()
        {
        public void widgetSelected(SelectionEvent event)
        {
            onBnSpawnGUI();
        }
        }
    );

    bn = new MyButton(shl, "Spawn &Console App").getButton();
    bn.addSelectionListener
    (
        new SelectionAdapter()
        {
        public void widgetSelected(SelectionEvent event)
        {
            onBnSpawnConsole();
        }
        }
    );

    bn = new MyButton(shl, "&Close").getButton();
    bn.addSelectionListener
    (
        new SelectionAdapter()
        {
        public void widgetSelected(SelectionEvent event)
        {
            onBnClose();
        }
        }
    );
}

// Message handlers

private void onBnSpawnGUI()
{
	Launcher.launchGUI("./GUILauncher.exe");
}

private void onBnSpawnConsole()
{
	m_lbl.setText(Launcher.launch("./HelloWorld.exe"));
}

private void onBnClose()
{
    System.exit(1);
}


////////////////////////////////////////////////////////////////////////
// nested class MyButton

private static class MyButton
{
MyButton(Composite cmp, String str)
{
    m_bn = new Button(cmp, SWT.PUSH);
    m_bn.setText(str);
    GridData gdta = new GridData();
    gdta.horizontalAlignment = GridData.CENTER;
    gdta.widthHint = 200;
    gdta.heightHint = 25;
    gdta.grabExcessHorizontalSpace = true;
    m_bn.setLayoutData(gdta);
}

final Button getButton()
{
    return m_bn;
}

// private //
private Button m_bn;
}

// nested class MyButton
////////////////////////////////////////////////////////////////////////

}
