import org.eclipse.swt.widgets.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.RowLayout;

import java.io.File;

public class HelloSWT {

    public static void main(String[] args) {
        Display display = new Display();
        final Shell shell = new Shell(display, SWT.SHELL_TRIM | SWT.NO_BACKGROUND |
		SWT.NO_REDRAW_RESIZE | SWT.V_SCROLL | SWT.H_SCROLL);
        RowLayout layout = new RowLayout();
        layout.justify = true;
        layout.pack = true;
        shell.setLayout(layout);
        shell.setText("Hello GCJ World!");
        Label label = new Label(shell, SWT.CENTER);

        label.setText("Hello, GCJ World!");
        Image originalImage =
          new Image
          (
              display,
              HelloSWT.class
                  .getResourceAsStream
                  (
                      "swt.gif"
                  )
          );
        final Image image = originalImage;
        final Point origin = new Point (0, 0);
        final ScrollBar hBar = shell.getHorizontalBar ();
        hBar.addListener (SWT.Selection, new Listener () {
            public void handleEvent (Event e) {
                int hSelection = hBar.getSelection ();
                int destX = -hSelection - origin.x;
                origin.x = -hSelection;
                Rectangle rect = image.getBounds ();
                shell.scroll (destX, 0, 0, 0, rect.width, rect.height, false);
            }
        });
        final ScrollBar vBar = shell.getVerticalBar ();
        vBar.addListener (SWT.Selection, new Listener () {
            public void handleEvent (Event e) {
                int vSelection = vBar.getSelection ();
                int destY = -vSelection - origin.y;
                origin.y = -vSelection;
                Rectangle rect = image.getBounds ();
                shell.scroll (0, destY, 0, 0, rect.width, rect.height, false);
            }
        });
        shell.addListener (SWT.Resize,  new Listener () {
            public void handleEvent (Event e) {
                Rectangle rect = image.getBounds ();
                Rectangle client = shell.getClientArea ();
                hBar.setMaximum (rect.width);
                vBar.setMaximum (rect.height);
                hBar.setThumb (Math.min (rect.width, client.width));
                vBar.setThumb (Math.min (rect.height, client.height));
                int hPage = rect.width - client.width;
                int vPage = rect.height - client.height;
                int hSelection = hBar.getSelection ();
                int vSelection = vBar.getSelection ();
                if (hSelection >= hPage) {
                    if (hPage <= 0) hSelection = 0;
                    origin.x = -hSelection;
                }
                if (vSelection >= vPage) {
                    if (vPage <= 0) vSelection = 0;
                    origin.y = -vSelection;
                }
                shell.redraw ();
            }
        });
        shell.addListener (SWT.Paint, new Listener () {
            public void handleEvent (Event e) {
                GC gc = e.gc;
                gc.drawImage (image, origin.x, origin.y);
                Rectangle rect = image.getBounds ();
                Rectangle client = shell.getClientArea ();
                int marginWidth = client.width - rect.width;
                if (marginWidth > 0) {
                    gc.fillRectangle (rect.width, 0, marginWidth, client.height);
                }
                int marginHeight = client.height - rect.height;
                if (marginHeight > 0) {
                    gc.fillRectangle (0, rect.height, client.width, marginHeight);
                }
            }
        });
        shell.setSize(500,150);
        //shell.pack();
        shell.open ();
        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) display.sleep ();
        }
       display.dispose ();
}
}
