import java.io.*;

/**
 * This class is a replacement for InetAddress.getLocalHost().
 *
 * @author  Erik Poupaert, June 2003, Brussels, Belgium
 */
public class TestProcess
{
	//===========================================================
	//GET LOCAL HOST NAME
	//===========================================================
	/**
	 * @return localhost name.
	*/
	public static String getLocalHostName() throws Exception
	{
		int exitValue=0;
		String hostName=null;
		Runtime aRuntime = Runtime.getRuntime();
		System.out.println(aRuntime);
		Process process=aRuntime.exec("hostname.exe");
		System.out.println(process);
		BufferedReader reader=
			new BufferedReader(new InputStreamReader(process.getInputStream()));
		hostName=reader.readLine();
		exitValue=process.waitFor();
		if(exitValue!=0)
		{
			throw new RuntimeException("cannot read hostname (exit "+exitValue+")");
		}
		return hostName;
	}
	//===========================================================
	//MAIN
	//===========================================================
	public static void main(String[] args)
	{
		try
		{
			System.out.println("hostname is: " + getLocalHostName());
		}
		catch (Exception e)
		{
			System.out.println(e.getClass().getName() + ": " + e.getMessage());
		}
	}
}
