public class TempUTFStrTest
{
public TempUTFStrTest(String str)
{
   this(str, null);
}

public TempUTFStrTest(String str1, String str2)
{
   m_str = str1;
   m_str2 = str2;
}

public final native void dump();
public final native void dump2();
public final native void dump3();

public static void main(String[] args)
{
   if (args.length==1 && args[0].equals("-stresstest"))
   {
      stresstest(args);
      return;
   }
   
   new TempUTFStrTest(null).dump();

   TempUTFStrTest a = new TempUTFStrTest("Flip", "Flop");
   a.dump();
   a.dump2();
   
   StringBuffer sbf = new StringBuffer("A long string:\n");
   for (int i=1; i<=500; ++i)
      sbf.append(i+"\n");
   new TempUTFStrTest(sbf.toString()).dump();
}
   
public static void stresstest(String[] args)
{
   StringBuffer
      sbfA = new StringBuffer(),
      sbfB = new StringBuffer();
      
   for (int i=0; i<500; ++i)
   {
      sbfA.append('0');
      sbfB.append('1');
   }
   
   String
      strA = sbfA.toString(),
      strB = sbfB.toString();
   
   long lStart = System.currentTimeMillis();
   for (int i=0; i<400000; ++i)
   {
      if ((i % 10000) == 0)
         System.err.println("Invocation: "+i);
      TempUTFStrTest a = new TempUTFStrTest(strA, strB);
      a.dump3();
   }
   System.gc();
   long lEnd = System.currentTimeMillis();
   System.err.println("Elapsed time (msecs): "+(lEnd-lStart));
}

// private //
private String m_str;
private String m_str2;
}
