#include "TempUTFStrTest.h"
#include <stdio.h>

#ifdef LINUX_HOST
	#include "/datal/gcc/gcc/libjava/include/jvm.h"
		// (i686-pc-linux-gnu,i686-pc-linux-gnu)
		// (i686-pc-linux-gnu,i686-pc-mingw32)
#else
	#include "k:/gcc/gcc/libjava/include/jvm.h"
		// (i686-pc-mingw32,i686-pc-mingw32)
#endif

#include <stdio.h>

static void print(const _Jv_TempUTFString& rcutfstr)
{
  if (rcutfstr)
    printf("%s\n", rcutfstr.buf());
  else
    printf("<null>\n");
}

static void dumpHeapAllocated(const _Jv_TempUTFString& rcutfstr)
{
  bool bIsHeapAllocated = *(const bool*) (((const char**) &rcutfstr) + 1);
  printf("Heap Allocated?: %s\n", bIsHeapAllocated ? "Yes" : "No");
}

void TempUTFStrTest::dump ()
{
	printf("=========================\n");
	printf("In native TempUTFStrTest::dump()\n");

	printf("Using _Jv_TempUTFString()...\n");
	_Jv_TempUTFString str(m_str);
  dumpHeapAllocated(str);
  print(str);
	printf("\n");

	printf("Using JV_TEMP_UTF_STRING...\n");
	JV_TEMP_UTF_STRING (str2, m_str);
  dumpHeapAllocated(str2);
	print(str2);
	printf("\n");

	printf("=========================\n");
	
}

void TempUTFStrTest::dump2 ()
{
  // Tests a complex expression as the second macro argument
  printf("=========================\n");
  printf("In native TempUTFStrTest::dump2()\n");

  printf("Using JV_TEMP_UTF_STRING...\n");
  for (int i=0; i<6; ++i)
  {
    JV_TEMP_UTF_STRING (tempstr, (i % 2) == 0 ? m_str : m_str2);
    dumpHeapAllocated(tempstr);
    print(tempstr);
    printf("\n");
  }

  printf("=========================\n");
  
}

void TempUTFStrTest::dump3 ()
{
  static int times = 0;
  JV_TEMP_UTF_STRING (tempstr, (times++ % 2) == 0 ? m_str : m_str2);
  print(tempstr);
}
